
<?php
////////////////////////////////////////////////////
// WHMCS Payment gateway module for Stripe Alipay
//
// Copyright (C) 2006 - 2017  RoudiApp.com - Bermouda Ltd.
//
// License:  license is commercial with the source code distributed under the GNU General Public License version 3.
// https://roudiapp.com/terms.html
// For support: hello@roudiapp.com
// Version 0.1
////////////////////////////////////////////////////

use \Stripe\Util\Util as Util;

// WHMCS Required File Includes
include("../../../init.php");
include("../../../includes/gatewayfunctions.php");
include("../../../includes/invoicefunctions.php");

if(isset($_GET['client_secret'])){

	$gatewaymodule = "roudiappstripealipay";

	$GATEWAY = getGatewayVariables($gatewaymodule);
	if (!$GATEWAY["type"]) die("Module Not Activated"); // Checks gateway module is active before accepting callback

	//get amount and invoice id
	$amount = intval((int)$_GET['amount']);
	$invoiceid = intval((int)$_GET['id']);

	//get publishable key
	if($GATEWAY['testmode']){
		$publishablekey = $GATEWAY["testpublishablekey"];
    	$secretkey = $GATEWAY["testsecretkey"];
    } else {
    	$publishablekey = $GATEWAY["publishablekey"];
    	$secretkey = $GATEWAY["secretkey"];
    }

	//set user id
    $userid = intval((int)$_GET['userid']);


	//set Stripe secret key
    \Stripe\Stripe::setApiKey($secretkey);

	$source = \Stripe\Source::retrieve($_GET['source']);


	if($source->status === "chargeable" && $source->client_secret === $_GET['client_secret']){

		$charge = \Stripe\Charge::create(array(
		  "amount" => $amount,
		  "currency" => $_GET['currency'],
		  "source" => $source->id,
		));

		// Get user and transaction currencies
		$userCurrency = getCurrency($userid);
		$transactionCurrency = select_query('tblcurrencies', '', array('code' => $charge->currency));
		$transactionCurrency = mysql_fetch_assoc($transactionCurrency);


		//convert to normal amount format for whmcs
		$amount = intval((int)$_GET['amount']) / 100;

		//check if charge was successful
		if($charge->status === "succeeded"){
			//check if payment currency is different from user currency
			if ($transactionCurrency['id'] != $userCurrency['id']) {
				$amount = convertCurrency($amount, $transactionCurrency['id'], $userCurrency['id']);
			}

			$transid = $charge->id;
			$chargefee = (($amount * $GATEWAY['transactionfeeper']) / 100) + ($GATEWAY['transactionfeefix'] / 100);

			$invoiceid = checkCbInvoiceID($invoiceid,$GATEWAY["name"]); // Checks invoice ID is a valid invoice number or ends processing

			checkCbTransID($charge->id); // Checks transaction number isn't already in the database and ends processing if it does

			// Successful
			addInvoicePayment($invoiceid,$transid,$amount,$chargefee,$gatewaymodule); // Apply Payment to Invoice: invoiceid, transactionid, amount paid, fees, modulename
			logTransaction($GATEWAY["name"],$charge,"Successful"); // Save to Gateway Log: name, data array, status

			header( "Location: " . $CONFIG["SystemURL"] . ( "/viewinvoice.php?id=" . $invoiceid . "&paymentsuccess=true" ) );
			exit();
			return 1;
		}

	} else {
		header( "Location: " . $CONFIG["SystemURL"] . "/clientarea.php" );
	}
}