<?php
////////////////////////////////////////////////////
// WHMCS Payment gateway module for Stripe Alipay
//
// Copyright (C) 2006 - 2017  RoudiApp.com - Bermouda Ltd.
//
// License:  license is commercial with the source code distributed under the GNU General Public License version 3.
// https://roudiapp.com/terms.html
// For support: hello@roudiapp.com
// Version 0.1
////////////////////////////////////////////////////

if (!defined( "WHMCS" )) {
	exit( "This file cannot be accessed directly" );
}

//use \Stripe\Stripe;
//use \Stripe\Source;
use \Stripe\Util\Util as Util;


function roudiappstripealipay_config() {
    $configarray = array(
     "FriendlyName" => array("Type" => "System", "Value"=>"RoudiApp Stripe Alipay"),
     "publishablekey" => array("FriendlyName" => "Live Publishable Key", "Type" => "text", "Size" => "45", ),
     "secretkey" => array("FriendlyName" => "Live Secret Key", "Type" => "text", "Size" => "45", ),
     "testpublishablekey" => array("FriendlyName" => "Test Publishable Key", "Type" => "text", "Size" => "45", ),
     "testsecretkey" => array("FriendlyName" => "Test Secret Key", "Type" => "text", "Size" => "45", ),
     "roudiapplogo" => array("FriendlyName" => "Site Logo", "Value"=>"https://yourdomain.com/logo.png", "Description" => "Logo on Strip Checkout Form, include https.", "Type" => "text", "Size" => "100", ),
     "maindomain" => array("FriendlyName" => "WHMCS Installation", "Value"=>"https://yourdomain.com/billing", "Description" => "URL to WHMCS installation, no forward slash at the end.", "Type" => "text", "Size" => "100", ),
     "bizname" => array("FriendlyName" => "Business name", "Value"=>"RoudiApp", "Description" => "Your business name on stripe checkout form.", "Type" => "text", "Size" => "45", ),
     "itemdesc" => array("FriendlyName" => "Item Description", "Value"=>"Company Services", "Description" => "Generic item description on stripe checkout form.", "Type" => "text", "Size" => "45", ),
     "customdesc" => array("FriendlyName" => "Customised Text", "Value"=>"Terms and Conditions", "Description" => "Generic customised text goes here.", "Type" => "text", "Size" => "150", ),
     "roudiappinvoicetag" => array("FriendlyName" => "Invoice Tag", "Value"=>"domain.com INVOICE # ", "Description" => "This will accompany invoice id on stripe record for easier tracking.", "Type" => "text", "Size" => "35", ),
     "roudiappbutton" => array("FriendlyName" => "Pay Button Text", "Value"=>"Pay Now", "Description" => "", "Type" => "text", "Size" => "45", ),
     "testmode" => array("FriendlyName" => "Test Mode", "Type" => "yesno", "Description" => "Enable Test Mode", ),
	 "currencycode" => array("FriendlyName" => "Currency Code", "Type" => "text", "Size" => "5", "Value"=>"gbp", "Description" => "Supported currencies are: aud, cad, eur, gbp, hkd, jpy, nzd, sgd, or usd", ),
	 "transactionfeeper" => array("FriendlyName" => "Transaction Fee %", "Type" => "text", "Size" => "5", "Value"=>"2.75", "Description" => "Value in percentage.", ),
	 "transactionfeefix" => array("FriendlyName" => "Transaction Fee Fix", "Type" => "text", "Size" => "5", "Value"=>"20", "Description" => "Fix value in pence or cents.", ),

     );
	return $configarray;
}

function roudiappstripealipay_link($params) {

	//get publishable key
	if($params['testmode']){
    	$publishablekey = $params["testpublishablekey"];
    } else {
    	$publishablekey = $params["publishablekey"];
    }

    //set Stripe secret key
    \Stripe\Stripe::setApiKey($secretkey);

	# Invoice Variables
	$invoiceid = $params['invoiceid'];
	$amount = $params['amount'] * 100; # must be in pence/cents

	/*if($params['currencycode'] == strtolower($params['currency']))
	{
		$currency = strtolower($params['currencycode']); # moStripe Currency Code
	} else {
		$currency = $params['currency']; # WHMCS Currency Code
	}*/

	$currency = strtolower($params['currency']); # WHMCS Currency Code


	//build the sha1 key to ensure the checkout amount is correct
	$mostripesha1_key = sha1("totalamount=".$amount."mostripeshakey=".$params['roudiappsha'].$publishablekey.$invoiceid);
	$alipay_return_url = $params['maindomain'] ."/modules/gateways/callback/roudiappstripealipay.php?id=". $invoiceid ."&amount=". $amount ."&currency=". $currency ."&userid=". $params["clientdetails"]["userid"];

	$code = '<!-- MoStripe New buy process -->
	<br /><br />

	<script src="https://code.jquery.com/jquery-1.10.2.min.js"></script>
	<script src="https://js.stripe.com/v3/"></script>
	<p><button id="mostripeOBT" class="btn btn-primary" title="moStripe Pay Now">'. $params['roudiappbutton'] .'</button></p>
	<p>'. $params['customdesc'] .'</p>
	<p id="resulterror"></p>
	<form action="#" method="post" id="roudifrm">
		<input type="hidden" name="invoiceid" value="'. $invoiceid .'" />
		<input type="hidden" name="amount" value="'. $amount .'" />
		<input type="hidden" name="mostripeshakey" value="'. $mostripesha1_key .'" />
		<input type="hidden" name="currency" value="'. $currency .'" />
		<input type="hidden" name="userid" value="'. $params["clientdetails"]["userid"] .'" />

	<script type="text/javascript">
		var stripe = Stripe( \''. $publishablekey .'\');

		jQuery(function($) {
		    $(\'#mostripeOBT\').click(function(){
			    stripe.createSource({
				  type: \'alipay\',
				  amount: '. $amount .',
				  currency: \''. $currency .'\',
				  redirect: {
				    return_url: \''. $alipay_return_url .'\',
				  },
				}).then(function(result) {
				  // handle result.error or result.source
				  if(result.error === \'payment_method_not_available\'){
					  $(\'#resulterror\').html(\'The payment method is currently not available\');
				  } else if(result.error === \'processing_error\'){
					  $(\'#resulterror\').html(\'An unexpected error occurred preventing us from creating your payment.\');
				  }
				  //if successfull
				  if(result.source){
					 $(location).attr(\'href\', result.source.redirect.url);
					 console.log(result.source);
				  }
				});

				return false;
		    });
		});
	</script>
	</form>
	<!-- MoStripe New buy process ends -->';

	return $code;
}


function roudiappstripealipay_refund($params) {

    //get publishable key
	if($params['testmode']){
    	$secretkey = $params["testsecretkey"];
    } else {
    	$secretkey = $params["secretkey"];
    }

    //set Stripe secret key
    \Stripe\Stripe::setApiKey($secretkey);

    # Invoice Variables
	$transid = $params['transid']; # Transaction ID of Original Payment
	$amount = $params['amount'] * 100; # must be in pence/cents
    $currency = $params['currency']; # Currency Code

    $results = array();

	try{

    	// Refund a transaction

    	if($amount > 0 && !empty($transid)){
    		//refund partial amount by providing the amount value
    		//refund customer
    		$refundedcharge = \Stripe\Refund::create(array(
    													"amount" => $amount,
    													"charge" => $transid
    												));
    	}

    	//refund object is returned if the refund is successful.
    	if($refundedcharge->status === "succeeded"){
    	    $results["transid"] = $refundedcharge->id;
			$results["status"] = "success";
		} else {
			$results["status"] = "error";
		}

    } catch(\Stripe\Error\Card $e) {
		// Stripe_CardError will be caught
		$body = $e->getJsonBody();
		$httpstatuscode = $e->getHttpStatus();
		$err  = $body['error'];
		$results["status"] = "error";
	} catch (\Stripe\Error\InvalidRequest $e) {
	  // Invalid parameters were supplied to Stripe's API
	  //$body = $e->getJsonBody();
	  $httpstatuscode = $e->getHttpStatus();
	  $results["status"] = "error";
	} catch (\Stripe\Error\Authentication $e) {
	  // Authentication with Stripe's API failed
	  //$body = $e->getJsonBody();
	  $httpstatuscode = $e->getHttpStatus();
	  $results["status"] = "error";
	} catch (\Stripe\Error\ApiConnection $e) {
	  // Network communication with Stripe failed
	  //$body = $e->getJsonBody();
	  $httpstatuscode = $e->getHttpStatus();
	  $results["status"] = "error";
	} catch (\Stripe\Error\Base $e) {
	  //$body = $e->getJsonBody();
	  $httpstatuscode = $e->getHttpStatus();
	  $results["status"] = "error";
	} catch (Exception $e) {
	  // Something else happened, completely unrelated to Stripe
	  //$body = $e->getJsonBody();
	  $httpstatuscode = $e->getHttpStatus();
	  $results["status"] = "error";
	}

	# Return Results
	if ($results["status"]=="success") {
		return array("status"=>"success","transid"=>$results["transid"],"rawdata"=>$refundedcharge);
	} elseif ($results["status"]=="declined") {
        return array("status"=>"declined","rawdata"=>$e ." #Status Code: ". $httpstatuscode);
    } else {
		return array("status"=>"error","rawdata"=>$e ." #Status Code: ". $httpstatuscode);
	}

}
?>